diff --git a/include/wicked/team.h b/include/wicked/team.h
index 94e93dced..8423c07b6 100644
--- a/include/wicked/team.h
+++ b/include/wicked/team.h
@@ -1,7 +1,7 @@
 /*
- *	Team device support
+ *	Team network interface support
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,14 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *      along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef NI_WICKED_TEAM_H
 #define NI_WICKED_TEAM_H
@@ -133,9 +127,8 @@ typedef struct ni_team_runner {
 	};
 } ni_team_runner_t;
 
-
 /*
- * link watch
+ * link watch type
  */
 typedef enum {
 	NI_TEAM_LINK_WATCH_ETHTOOL = 0,
@@ -144,7 +137,6 @@ typedef enum {
 	NI_TEAM_LINK_WATCH_TIPC,
 } ni_team_link_watch_type_t;
 
-
 /*
  * link watch type structs
  */
@@ -178,7 +170,6 @@ typedef struct ni_team_link_watch_ethtool {
 	unsigned int				delay_down;
 } ni_team_link_watch_ethtool_t;
 
-
 /*
  * link watch type union
  */
@@ -208,6 +199,9 @@ typedef struct ni_team_port_lacp {
 	unsigned int				key;
 } ni_team_port_lacp_t;
 
+/*
+ * team port (link-request) configuration
+ */
 struct ni_team_port_config {
 	unsigned int				queue_id;
 
@@ -216,18 +210,37 @@ struct ni_team_port_config {
 };
 
 /*
- * team port and array
+ * team port interface info properties
  */
-typedef struct ni_team_port {
-	ni_netdev_ref_t				device;
-	ni_team_port_config_t			config;
-} ni_team_port_t;
+typedef struct ni_team_port_runner_lacp_info	ni_team_port_runner_lacp_info_t;
+typedef struct ni_team_port_runner_info		ni_team_port_runner_info_t;
+typedef struct ni_team_port_link_watches_info	ni_team_port_link_watches_info_t;
+
+struct ni_team_port_runner_lacp_info {
+	struct {
+		unsigned int			id;
+	} aggregator;
+	ni_bool_t				selected;
+	char *					state;
+};
+struct ni_team_port_runner_info {
+	ni_team_runner_type_t			type;
+	union {
+		ni_team_port_runner_lacp_info_t	lacp;
+	};
+};
+struct ni_team_port_link_watches_info {
+	ni_bool_t				up;
+};
 
-typedef struct ni_team_port_array {
-	unsigned int				count;
-	ni_team_port_t **			data;
-} ni_team_port_array_t;
+struct ni_team_port_info {
+	ni_team_port_runner_info_t		runner;
+	ni_team_port_link_watches_info_t	watches;
+};
 
+/*
+ * team interface
+ */
 typedef enum {
 	NI_TEAM_LINK_WATCH_POLICY_ANY = 0U,
 	NI_TEAM_LINK_WATCH_POLICY_ALL = 1,
@@ -242,9 +255,7 @@ typedef struct ni_team_mcast_rejoin {
 	unsigned int				count;
 	unsigned int				interval;
 } ni_team_mcast_rejoin_t;
-/*
- * team device
- */
+
 struct ni_team {
 	unsigned int				debug_level;
 	ni_team_notify_peers_t			notify_peers;
@@ -252,10 +263,8 @@ struct ni_team {
 	ni_team_runner_t			runner;
 	ni_team_link_watch_policy_t		link_watch_policy;
 	ni_team_link_watch_array_t		link_watch;
-	ni_team_port_array_t			ports;
 };
 
-
 extern ni_team_t *				ni_team_new();
 extern void					ni_team_free(ni_team_t *);
 
@@ -267,36 +276,39 @@ extern ni_bool_t				ni_team_runner_name_to_type(const char *, ni_team_runner_typ
 
 extern const char *				ni_team_tx_hash_bit_to_name(ni_team_tx_hash_bit_t);
 extern ni_bool_t				ni_team_tx_hash_name_to_bit(const char *, ni_team_tx_hash_bit_t *);
-extern unsigned int				ni_team_tx_hash_get_bit_names(ni_team_tx_hash_bit_t, ni_string_array_t *);
+extern unsigned int				ni_team_tx_hash_get_bit_names(ni_team_tx_hash_bit_t,
+								ni_string_array_t *);
 extern const char *				ni_team_tx_balancer_type_to_name(ni_team_tx_balancer_type_t);
-extern ni_bool_t				ni_team_tx_balancer_name_to_type(const char *, ni_team_tx_balancer_type_t *);
+extern ni_bool_t				ni_team_tx_balancer_name_to_type(const char *,
+								ni_team_tx_balancer_type_t *);
 
 extern const char *				ni_team_lacp_select_policy_type_to_name(ni_team_lacp_select_policy_t);
-extern ni_bool_t				ni_team_lacp_select_policy_name_to_type(const char *, ni_team_lacp_select_policy_t *);
+extern ni_bool_t				ni_team_lacp_select_policy_name_to_type(const char *,
+								ni_team_lacp_select_policy_t *);
 
 extern const char *				ni_team_ab_hwaddr_policy_type_to_name(ni_team_ab_hwaddr_policy_t);
-extern ni_bool_t				ni_team_ab_hwaddr_policy_name_to_type(const char *, ni_team_ab_hwaddr_policy_t *);
+extern ni_bool_t				ni_team_ab_hwaddr_policy_name_to_type(const char *,
+								ni_team_ab_hwaddr_policy_t *);
 
 extern const char *				ni_team_link_watch_type_to_name(ni_team_link_watch_type_t);
-extern ni_bool_t				ni_team_link_watch_name_to_type(const char *, ni_team_link_watch_type_t *);
+extern ni_bool_t				ni_team_link_watch_name_to_type(const char *,
+								ni_team_link_watch_type_t *);
 
 extern const char *				ni_team_link_watch_policy_type_to_name(ni_team_link_watch_policy_t);
 extern ni_bool_t				ni_team_link_watch_policy_name_to_type(const char *,
-											ni_team_link_watch_policy_t *);
+								ni_team_link_watch_policy_t *);
 
 extern ni_team_link_watch_t *			ni_team_link_watch_new(ni_team_link_watch_type_t);
 extern void					ni_team_link_watch_free(ni_team_link_watch_t *);
 extern						ni_declare_ptr_array_append(ni_team_link_watch);
 extern						ni_declare_ptr_array_delete_at(ni_team_link_watch);
 
-extern ni_team_port_t *				ni_team_port_new(void);
-extern void					ni_team_port_free(ni_team_port_t *);
-extern						ni_declare_ptr_array_destroy(ni_team_port);
-extern						ni_declare_ptr_array_append(ni_team_port);
-extern						ni_declare_ptr_array_delete_at(ni_team_port);
-extern ni_team_port_t *				ni_team_port_array_find_by_name(ni_team_port_array_t *, const char *);
-
-extern void					ni_team_port_config_init(ni_team_port_config_t *);
+extern ni_team_port_config_t *			ni_team_port_config_new(void);
+extern ni_bool_t				ni_team_port_config_init(ni_team_port_config_t *);
 extern void					ni_team_port_config_destroy(ni_team_port_config_t *);
+extern void					ni_team_port_config_free(ni_team_port_config_t *);
+
+extern ni_team_port_info_t *			ni_team_port_info_new(void);
+extern void					ni_team_port_info_free(ni_team_port_info_t *);
 
 #endif /* NI_WICKED_TEAM_H */
diff --git a/include/wicked/types.h b/include/wicked/types.h
index 986012a0f..506bc1827 100644
--- a/include/wicked/types.h
+++ b/include/wicked/types.h
@@ -11,7 +11,7 @@
 #include <sys/types.h>
 #include <stdint.h>
 
-typedef unsigned char		ni_bool_t;
+typedef unsigned char				ni_bool_t;
 #ifndef TRUE
 # define TRUE 1
 #endif
@@ -20,126 +20,131 @@ typedef unsigned char		ni_bool_t;
 #endif
 
 typedef enum {
-	NI_TRISTATE_DEFAULT	= -1,
-	NI_TRISTATE_DISABLE	= 0,
-	NI_TRISTATE_ENABLE	= 1
+	NI_TRISTATE_DEFAULT			= -1,
+	NI_TRISTATE_DISABLE			= 0,
+	NI_TRISTATE_ENABLE			= 1
 } ni_tristate_t;
 
-typedef unsigned long long	ni_timeout_t;
-
-typedef union  ni_sockaddr	ni_sockaddr_t;
-typedef struct ni_netconfig	ni_netconfig_t;
-typedef struct ni_netdev	ni_netdev_t;
-typedef struct ni_route		ni_route_t;
-typedef struct ni_route_table	ni_route_table_t;
-typedef struct ni_rule		ni_rule_t;
-typedef struct ni_rule_array	ni_rule_array_t;
-typedef struct ni_vlan		ni_vlan_t;
-typedef struct ni_vxlan		ni_vxlan_t;
-typedef struct ni_macvlan	ni_macvlan_t;
-typedef struct ni_bridge	ni_bridge_t;
-typedef struct ni_bridge_port	ni_bridge_port_t;
-typedef struct ni_ovs_bridge	ni_ovs_bridge_t;
-typedef struct ni_ovs_bridge_port_config ni_ovs_bridge_port_config_t;
-typedef struct ni_bonding	ni_bonding_t;
-typedef struct ni_bonding_slave_info	ni_bonding_slave_info_t;
-typedef struct ni_team		ni_team_t;
-typedef struct ni_team_port_config ni_team_port_config_t;
-typedef struct ni_wireless	ni_wireless_t;
-typedef struct ni_ethtool	ni_ethtool_t;
-typedef struct ni_ethernet	ni_ethernet_t;
-typedef struct ni_infiniband	ni_infiniband_t;
-typedef struct ni_openvpn	ni_openvpn_t;
-typedef struct ni_tuntap	ni_tuntap_t;
-typedef struct ni_tunnel	ni_tunnel_t;
-typedef struct ni_sit		ni_sit_t;
-typedef struct ni_ipip		ni_ipip_t;
-typedef struct ni_gre		ni_gre_t;
-typedef struct ni_ppp		ni_ppp_t;
-typedef struct ni_dcb		ni_dcb_t;
-typedef struct ni_lldp		ni_lldp_t;
-typedef struct ni_nis_info	ni_nis_info_t;
-typedef struct ni_resolver_info	ni_resolver_info_t;
-typedef struct ni_addrconf_lease  ni_addrconf_lease_t;
-typedef struct ni_auto4_request	ni_auto4_request_t;
-typedef struct ni_netdev_req	ni_netdev_req_t;
-typedef struct ni_ipv4_devinfo	ni_ipv4_devinfo_t;
-typedef struct ni_ipv4_devconf	ni_ipv4_devconf_t;
-typedef struct ni_ipv6_devinfo	ni_ipv6_devinfo_t;
-typedef struct ni_ipv6_devconf	ni_ipv6_devconf_t;
-typedef struct ni_auto6		ni_auto6_t;
-typedef struct ni_event_filter	ni_event_filter_t;
-typedef struct ni_modem		ni_modem_t;
-typedef struct ni_pci_dev	ni_pci_dev_t;
+typedef unsigned long long			ni_timeout_t;
+
+typedef union  ni_sockaddr			ni_sockaddr_t;
+typedef struct ni_netconfig			ni_netconfig_t;
+typedef struct ni_netdev			ni_netdev_t;
+typedef struct ni_route				ni_route_t;
+typedef struct ni_route_table			ni_route_table_t;
+typedef struct ni_rule				ni_rule_t;
+typedef struct ni_rule_array			ni_rule_array_t;
+typedef struct ni_vlan				ni_vlan_t;
+typedef struct ni_vxlan				ni_vxlan_t;
+typedef struct ni_macvlan			ni_macvlan_t;
+typedef struct ni_bridge			ni_bridge_t;
+typedef struct ni_bridge_port			ni_bridge_port_t;
+typedef struct ni_bridge_port_info		ni_bridge_port_info_t;
+typedef struct ni_bridge_port_config		ni_bridge_port_config_t;
+typedef struct ni_ovs_bridge			ni_ovs_bridge_t;
+typedef struct ni_ovs_bridge_port_info		ni_ovs_bridge_port_info_t;
+typedef struct ni_ovs_bridge_port_config	ni_ovs_bridge_port_config_t;
+typedef struct ni_bonding			ni_bonding_t;
+typedef struct ni_bonding_port_info		ni_bonding_port_info_t;
+typedef struct ni_bonding_port_config		ni_bonding_port_config_t;
+typedef struct ni_team				ni_team_t;
+typedef struct ni_team_port_info		ni_team_port_info_t;
+typedef struct ni_team_port_config		ni_team_port_config_t;
+typedef struct ni_wireless			ni_wireless_t;
+typedef struct ni_ethtool			ni_ethtool_t;
+typedef struct ni_ethernet			ni_ethernet_t;
+typedef struct ni_infiniband			ni_infiniband_t;
+typedef struct ni_openvpn			ni_openvpn_t;
+typedef struct ni_tuntap			ni_tuntap_t;
+typedef struct ni_tunnel			ni_tunnel_t;
+typedef struct ni_sit				ni_sit_t;
+typedef struct ni_ipip				ni_ipip_t;
+typedef struct ni_gre				ni_gre_t;
+typedef struct ni_ppp				ni_ppp_t;
+typedef struct ni_dcb				ni_dcb_t;
+typedef struct ni_lldp				ni_lldp_t;
+typedef struct ni_nis_info			ni_nis_info_t;
+typedef struct ni_resolver_info			ni_resolver_info_t;
+typedef struct ni_addrconf_lease		ni_addrconf_lease_t;
+typedef struct ni_auto4_request			ni_auto4_request_t;
+typedef struct ni_netdev_req			ni_netdev_req_t;
+typedef struct ni_ipv4_devinfo			ni_ipv4_devinfo_t;
+typedef struct ni_ipv4_devconf			ni_ipv4_devconf_t;
+typedef struct ni_ipv6_devinfo			ni_ipv6_devinfo_t;
+typedef struct ni_ipv6_devconf			ni_ipv6_devconf_t;
+typedef struct ni_auto6				ni_auto6_t;
+typedef struct ni_event_filter			ni_event_filter_t;
+typedef struct ni_modem				ni_modem_t;
+typedef struct ni_pci_dev			ni_pci_dev_t;
 
 typedef struct ni_netdev_ref {
-	unsigned int		index;	/* by ifindex */
-	char *			name;	/* by ifname  */
+	unsigned int				index;	/* by ifindex */
+	char *					name;	/* by ifname  */
 } ni_netdev_ref_t;
 
-#define NI_NETDEV_REF_INIT		{ .index = 0, .name = NULL }
+#define NI_NETDEV_REF_INIT			{ .index = 0, .name = NULL }
 
 typedef struct ni_netdev_ref_array {
-	unsigned int		count;
-	ni_netdev_ref_t *	data;
+	unsigned int				count;
+	ni_netdev_ref_t *			data;
 } ni_netdev_ref_array_t;
 
-#define NI_NETDEV_REF_ARRAY_INIT	{ .count = 0, .data = NULL }
+#define NI_NETDEV_REF_ARRAY_INIT		{ .count = 0, .data = NULL }
 
-typedef struct ni_dbus_server	ni_dbus_server_t;
-typedef struct ni_dbus_client	ni_dbus_client_t;
+typedef struct ni_dbus_server			ni_dbus_server_t;
+typedef struct ni_dbus_client			ni_dbus_client_t;
 
-typedef struct ni_socket	ni_socket_t;
-typedef struct ni_socket_array	ni_socket_array_t;
-typedef struct ni_buffer	ni_buffer_t;
-typedef struct ni_extension	ni_extension_t;
-typedef struct ni_script_action	ni_script_action_t;
+typedef struct ni_socket			ni_socket_t;
+typedef struct ni_socket_array			ni_socket_array_t;
+typedef struct ni_buffer			ni_buffer_t;
+typedef struct ni_extension			ni_extension_t;
+typedef struct ni_script_action			ni_script_action_t;
 
-typedef struct ni_shellcmd	ni_shellcmd_t;
-typedef struct ni_process	ni_process_t;
+typedef struct ni_shellcmd			ni_shellcmd_t;
+typedef struct ni_process			ni_process_t;
 
 /*
  * These are used by the XML and XPATH code.
  */
-typedef struct xpath_format		xpath_format_t;
-typedef struct xpath_enode		xpath_enode_t;
-typedef struct xml_document		xml_document_t;
-typedef struct xml_document_array	xml_document_array_t;
-typedef struct xml_node			xml_node_t;
-typedef struct xml_location		xml_location_t;
-
-typedef struct ni_xs_type		ni_xs_type_t;
-typedef struct ni_xs_scope		ni_xs_scope_t;
-typedef struct ni_xs_method		ni_xs_method_t;
-typedef struct ni_xs_service		ni_xs_service_t;
+typedef struct xpath_format			xpath_format_t;
+typedef struct xpath_enode			xpath_enode_t;
+typedef struct xml_document			xml_document_t;
+typedef struct xml_document_array		xml_document_array_t;
+typedef struct xml_node				xml_node_t;
+typedef struct xml_location			xml_location_t;
+
+typedef struct ni_xs_type			ni_xs_type_t;
+typedef struct ni_xs_scope			ni_xs_scope_t;
+typedef struct ni_xs_method			ni_xs_method_t;
+typedef struct ni_xs_service			ni_xs_service_t;
 
 typedef struct xpath_format_array {
-	unsigned int		count;
-	xpath_format_t **	data;
+	unsigned int				count;
+	xpath_format_t **			data;
 } xpath_format_array_t;
 
 typedef union ni_uuid {
-	unsigned char		octets[16];
-	uint16_t		shorts[8];
-	uint32_t		words[4];
+	unsigned char				octets[16];
+	uint16_t				shorts[8];
+	uint32_t				words[4];
 } ni_uuid_t;
-#define NI_UUID_INIT		{ .words = { 0, 0, 0, 0 } }
+#define NI_UUID_INIT				{ .words = { 0, 0, 0, 0 } }
 
 /*
  * Link layer address
  */
-#define NI_MAXHWADDRLEN		64
+#define NI_MAXHWADDRLEN				64
 typedef struct ni_hwaddr {
-	unsigned short		type;
-	unsigned short		len;
-	unsigned char		data[NI_MAXHWADDRLEN];
+	unsigned short				type;
+	unsigned short				len;
+	unsigned char				data[NI_MAXHWADDRLEN];
 } ni_hwaddr_t;
 
 /*
  * Range of unsigned values
  */
 typedef struct ni_uint_range {
-	unsigned int		min, max;
+	unsigned int				min, max;
 } ni_uint_range_t;
 
 static inline void
@@ -160,26 +165,26 @@ ni_uint_range_update_max(ni_uint_range_t *r, unsigned int max)
  * Range of signed values
  */
 typedef struct ni_int_range {
-	int			min, max;
+	int					min, max;
 } ni_int_range_t;
 
 /*
  * Prototypes for ipv6 devinfo RA details
  */
-typedef struct ni_ipv6_ra_info	ni_ipv6_ra_info_t;
-typedef struct ni_ipv6_ra_pinfo	ni_ipv6_ra_pinfo_t;
+typedef struct ni_ipv6_ra_info			ni_ipv6_ra_info_t;
+typedef struct ni_ipv6_ra_pinfo			ni_ipv6_ra_pinfo_t;
 
 /*
  * Custom dhcp option declaration
  */
-typedef struct ni_dhcp_option_decl ni_dhcp_option_decl_t;
+typedef struct ni_dhcp_option_decl		ni_dhcp_option_decl_t;
 
 /*
  * Common DHCPv6 declarations
  */
-typedef struct ni_dhcp6_status		ni_dhcp6_status_t;
-typedef struct ni_dhcp6_ia		ni_dhcp6_ia_t;
-typedef struct ni_dhcp6_ia_addr		ni_dhcp6_ia_addr_t;
-typedef struct ni_dhcp6_prefix_req	ni_dhcp6_prefix_req_t;
+typedef struct ni_dhcp6_status			ni_dhcp6_status_t;
+typedef struct ni_dhcp6_ia			ni_dhcp6_ia_t;
+typedef struct ni_dhcp6_ia_addr			ni_dhcp6_ia_addr_t;
+typedef struct ni_dhcp6_prefix_req		ni_dhcp6_prefix_req_t;
 
 #endif /* NI_WICKED_TYPES_H */
diff --git a/include/wicked/util.h b/include/wicked/util.h
index 28871c938..54b8c888c 100644
--- a/include/wicked/util.h
+++ b/include/wicked/util.h
@@ -113,6 +113,7 @@ extern void		ni_string_free(char **);
 extern void		ni_string_clear(char **);
 extern ni_bool_t	ni_string_dup(char **, const char *);
 extern ni_bool_t	ni_string_set(char **, const char *, size_t len);
+extern ni_bool_t	ni_string_move(char **, char **);
 extern const char *	ni_string_printf(char **, const char *, ...);
 
 extern void		ni_string_array_init(ni_string_array_t *);
diff --git a/include/wicked/xml.h b/include/wicked/xml.h
index dbf3a80e4..b90750589 100644
--- a/include/wicked/xml.h
+++ b/include/wicked/xml.h
@@ -3,7 +3,8 @@
  *	This basically parses tags, attributes and CDATA, and that's
  *	just about it.
  *
- *	Copyright (C) 2009-2012  Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -15,30 +16,25 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write 
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
- *	Boston, MA 02110-1301 USA.
- *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
-
-#ifndef __WICKED_XML_H__
-#define __WICKED_XML_H__
+#ifndef NI_WICKED_XML_H
+#define NI_WICKED_XML_H
 
 #include <stdio.h>
 #include <wicked/util.h>
 #include <wicked/types.h>
+#include <wicked/array.h>
 
 struct xml_document {
 	char *			dtd;
 	struct xml_node *	root;
 };
 
-struct xml_document_array {
-	unsigned int		count;
-	xml_document_t **	data;
-};
-#define XML_DOCUMENT_ARRAY_INIT	{ 0, NULL }
+ni_declare_ptr_array_struct(xml_document);
+
+#define XML_DOCUMENT_ARRAY_INIT	NI_ARRAY_INIT
 
 struct xml_location_shared {
 	unsigned int		refcount;
@@ -67,12 +63,9 @@ struct xml_node {
 	xml_location_t *	location;
 };
 
-typedef struct xml_node_array	xml_node_array_t;
-struct xml_node_array {
-	unsigned int		count;
-	xml_node_t **		data;
-};
-#define XML_NODE_ARRAY_INIT	{ 0, NULL }
+ni_declare_ptr_array_type(xml_node);
+
+#define XML_NODE_ARRAY_INIT	NI_ARRAY_INIT
 
 extern xml_document_t *	xml_document_read(const char *);
 extern xml_document_t *	xml_document_scan(FILE *, const char *location);
@@ -90,6 +83,8 @@ extern xml_node_t *	xml_document_root(xml_document_t *);
 extern void		xml_document_set_root(xml_document_t *, xml_node_t *);
 extern xml_node_t *	xml_document_take_root(xml_document_t *);
 extern void		xml_document_free(xml_document_t *);
+extern xml_document_t *	xml_document_create(const char *, xml_node_t *);
+extern ni_bool_t	xml_document_expand(xml_document_array_t *, xml_document_t *);
 
 extern xml_node_t *	xml_node_new(const char *ident, xml_node_t *);
 extern xml_node_t *	xml_node_new_element(const char *ident, xml_node_t *, const char *cdata);
@@ -110,16 +105,16 @@ extern int		xml_node_content_uuid(const xml_node_t *, unsigned int, const ni_uui
 extern int		xml_node_print_fn(const xml_node_t *, void (*)(const char *, void *), void *);
 extern int		xml_node_print_debug(const xml_node_t *, unsigned int facility);
 extern xml_node_t *	xml_node_scan(FILE *fp, const char *location);
-extern void		xml_node_set_cdata(xml_node_t *, const char *);
-extern void		xml_node_set_int(xml_node_t *, int);
-extern void		xml_node_set_int64(xml_node_t *, int64_t);
-extern void		xml_node_set_uint(xml_node_t *, unsigned int);
-extern void		xml_node_set_uint64(xml_node_t *, uint64_t);
-extern void		xml_node_set_uint_hex(xml_node_t *, unsigned int);
-extern void		xml_node_add_attr(xml_node_t *, const char *, const char *);
-extern void		xml_node_add_attr_uint(xml_node_t *, const char *, unsigned int);
-extern void		xml_node_add_attr_ulong(xml_node_t *, const char *, unsigned long);
-extern void		xml_node_add_attr_double(xml_node_t *, const char *, double);
+extern ni_bool_t	xml_node_set_cdata(xml_node_t *, const char *);
+extern ni_bool_t	xml_node_set_int(xml_node_t *, int);
+extern ni_bool_t	xml_node_set_int64(xml_node_t *, int64_t);
+extern ni_bool_t	xml_node_set_uint(xml_node_t *, unsigned int);
+extern ni_bool_t	xml_node_set_uint64(xml_node_t *, uint64_t);
+extern ni_bool_t	xml_node_set_uint_hex(xml_node_t *, unsigned int);
+extern ni_bool_t	xml_node_add_attr(xml_node_t *, const char *, const char *);
+extern ni_bool_t	xml_node_add_attr_uint(xml_node_t *, const char *, unsigned int);
+extern ni_bool_t	xml_node_add_attr_ulong(xml_node_t *, const char *, unsigned long);
+extern ni_bool_t	xml_node_add_attr_double(xml_node_t *, const char *, double);
 
 extern ni_bool_t	xml_node_has_attr(const xml_node_t *, const char *);
 extern ni_bool_t	xml_node_del_attr(xml_node_t *, const char *);
@@ -130,6 +125,7 @@ extern ni_bool_t	xml_node_get_attr_ulong(const xml_node_t *, const char *, unsig
 extern ni_bool_t	xml_node_get_attr_double(const xml_node_t *, const char *, double *);
 extern xml_node_t *	xml_node_get_child(const xml_node_t *, const char *);
 extern xml_node_t *	xml_node_get_next_child(const xml_node_t *, const char *, const xml_node_t *);
+extern const char *	xml_node_get_child_cdata(const xml_node_t *, const char *);
 extern xml_node_t *	xml_node_get_child_with_attrs(const xml_node_t *, const char *,
 					const ni_var_array_t *);
 extern ni_bool_t	xml_node_replace_child(xml_node_t *, xml_node_t *);
@@ -155,18 +151,6 @@ extern void		xml_node_location_set(xml_node_t *, xml_location_t *);
 extern void		xml_node_location_modify(xml_node_t *, const char *);
 extern void		xml_node_location_relocate(xml_node_t *, const char *);
 
-extern void		xml_document_array_init(xml_document_array_t *);
-extern void		xml_document_array_destroy(xml_document_array_t *);
-extern xml_document_array_t *		xml_document_array_new(void);
-extern void		xml_document_array_free(xml_document_array_t *);
-extern void		xml_document_array_append(xml_document_array_t *, xml_document_t *);
-
-extern void		xml_node_array_init(xml_node_array_t *);
-extern void		xml_node_array_destroy(xml_node_array_t *);
-extern void		xml_node_array_append(xml_node_array_t *, xml_node_t *);
-extern xml_node_array_t *xml_node_array_new(void);
-extern void		xml_node_array_free(xml_node_array_t *);
-
 extern xml_node_t*	xml_node_create(xml_node_t *, const char *);
 extern void		xml_node_dict_set(xml_node_t *, const char *, const char *);
 
@@ -185,4 +169,16 @@ xml_document_is_empty(const xml_document_t *doc)
 	return (!doc || xml_node_is_empty(doc->root));
 }
 
-#endif /* __WICKED_XML_H__ */
+extern			ni_declare_ptr_array_init(xml_document);
+extern			ni_declare_ptr_array_destroy(xml_document);
+extern			ni_declare_ptr_array_append(xml_document);
+extern			ni_declare_ptr_array_insert(xml_document);
+extern			ni_declare_ptr_array_index(xml_document);
+
+extern			ni_declare_ptr_array_init(xml_node);
+extern			ni_declare_ptr_array_destroy(xml_node);
+extern			ni_declare_ptr_array_append(xml_node);
+extern xml_node_array_t *xml_node_array_new(void);
+extern void		xml_node_array_free(xml_node_array_t *);
+
+#endif /* NI_WICKED_XML_H */
diff --git a/nanny/main.c b/nanny/main.c
index 6090a63c3..a7fa17937 100644
--- a/nanny/main.c
+++ b/nanny/main.c
@@ -211,21 +211,22 @@ ni_nanny_statedir(void)
 }
 
 static ni_bool_t
-ni_nanny_policy_load(ni_nanny_t *mgr)
+ni_nanny_load_policies(ni_nanny_t *mgr)
 {
+	xml_document_array_t docs = XML_DOCUMENT_ARRAY_INIT;
 	ni_string_array_t files = NI_STRING_ARRAY_INIT;
 	char nanny_dir[PATH_MAX] = { '\0' };
+	xml_document_t *doc;
+	char *path = NULL;
 
 	ni_assert(mgr);
-	ni_debug_application("Loading previously saved policies:");
+	ni_debug_application("Loading previously saved policies");
 
 	snprintf(nanny_dir, sizeof(nanny_dir), "%s", ni_nanny_statedir());
 	if (ni_scandir(nanny_dir, "policy*.xml", &files) != 0) {
 		unsigned int i;
 
 		for (i = 0; i < files.count; ++i) {
-			char *path = NULL;
-			xml_document_t *doc;
 
 			if (!ni_string_printf(&path, "%s/%s", nanny_dir, files.data[i]))
 				continue;
@@ -235,20 +236,56 @@ ni_nanny_policy_load(ni_nanny_t *mgr)
 				ni_string_free(&path);
 				continue;
 			}
+			ni_string_free(&path);
 
-			if (!ni_nanny_create_policy(NULL, mgr, doc, NULL, TRUE)) {
-				ni_error("Unable to create policy from file '%s'", path);
+			if (!xml_document_expand(&docs, doc)) {
+				ni_error("Unable to allocate policy doc array memory: %m");
+				xml_document_free(doc);
+				continue;
 			}
+		}
 
-			ni_string_free(&path);
-			xml_document_free(doc);
+		if (ni_ifxml_migrate_docs(&docs))
+			ni_debug_readwrite("Migrated nanny policies to current schema");
+
+		for (i = 0; i < docs.count; ++i) {
+			doc = docs.data[i];
+			ni_bool_t migrated;
+			const char *name;
+
+			migrated = ni_ifxml_node_is_migrated(doc->root);
+			if (migrated) {
+				name = ni_ifpolicy_get_name(doc->root);
+
+				ni_ifxml_node_set_migrated(doc->root, FALSE);
+				if (ni_nanny_policy_file_path(&path, name) &&
+				    ni_nanny_policy_save(doc->root, path, NI_NANNY_POLICY_BAK)) {
+					ni_debug_verbose(NI_LOG_DEBUG1, NI_TRACE_READWRITE,
+							"- saved migrated policy to file '%s'",
+							path);
+				}
+				ni_string_free(&path);
+			}
+		}
+
+		for (i = 0; i < docs.count; ++i) {
+			doc = docs.data[i];
+			const char *from;
+
+			if (!ni_nanny_create_policy(NULL, mgr, doc, NULL, TRUE)) {
+				from = xml_node_location_filename(doc->root);
+				ni_error("Unable to create policy from file '%s'",
+						from ? from : "<migrated>");
+			}
 		}
 	}
+	ni_string_array_destroy(&files);
 
-	if (files.count)
+	if (docs.count)
 		ni_nanny_recheck_policies(mgr, NULL);
 
-	ni_string_array_destroy(&files);
+	xml_document_array_destroy(&docs);
+
 	return TRUE;
 }
 
@@ -280,7 +317,7 @@ babysit(void)
 
 	ni_rfkill_open(handle_rfkill_event, mgr);
 	ni_nanny_discover_state(mgr);
-	ni_nanny_policy_load(mgr);
+	ni_nanny_load_policies(mgr);
 
 #ifdef HAVE_SYSTEMD_SD_DAEMON_H
 	if (opt_systemd) {
diff --git a/nanny/nanny.c b/nanny/nanny.c
index ed024684a..9a4fb2f3a 100644
--- a/nanny/nanny.c
+++ b/nanny/nanny.c
@@ -321,7 +321,7 @@ ni_nanny_create_managed_policy(ni_dbus_object_t **policy_object, ni_nanny_t *mgr
 /*
  * Creates nanny policy and register managed policy interface.
  * Return:
- *     -1 - policy node does not exist or is errornous
+ *     -1 - policy node does not exist or is erroneous
  *      0 - policy already exists
  *      1 - policy created and registered
  */
@@ -331,29 +331,33 @@ ni_nanny_create_policy(ni_dbus_object_t **policy_object, ni_nanny_t *mgr, xml_do
 {
 	xml_node_t *root, *pnode = NULL;
 	ni_fsm_policy_t *policy = NULL;
+	char *location = NULL;
 	const char *pname;
 	int rv = -1;
 
 	if (!mgr || !mgr->fsm)
 		return -1;
 
-	if (!doc || xml_document_is_empty(doc)) {
+	if (!doc || !(root = xml_document_root(doc))) {
 		ni_error("Invalid policy document");
 		goto error;
 	}
 
-	root = xml_document_root(doc);
 	if (xml_node_is_empty(root->children)) {
 		ni_error("Policy document is empty");
 		goto error;
 	}
 
-	if (!xml_node_is_empty(root->children->next)) {
-		ni_error("Policy document contains more then one node");
-		goto error;
+	if (ni_string_empty(root->name)) {
+		if (!xml_node_is_empty(root->children->next)) {
+			ni_error("Policy document contains more then one node");
+			goto error;
+		}
+		pnode = root->children;
+	} else {
+		pnode = root;
 	}
 
-	pnode = root->children;
 	if (!ni_ifconfig_is_policy(pnode)) {
 		pname = pnode->name;
 		ni_error("Not a valid policy document node \"%s\"",
@@ -375,12 +379,14 @@ ni_nanny_create_policy(ni_dbus_object_t **policy_object, ni_nanny_t *mgr, xml_do
 		goto error;
 	}
 
-	if (ni_ifconfig_migrate(pnode))
-		ni_debug_nanny("Migrated policy \"%s\" to current schema", pname);
-
 	if (caller_uid)
 		ni_ifpolicy_set_owner_uid(pnode, *caller_uid);
 
+	if (ni_nanny_policy_location(&location, pname)) {
+		xml_node_location_relocate(pnode, location);
+		ni_string_free(&location);
+	}
+
 	if (!(policy = ni_fsm_policy_new(mgr->fsm, pname, pnode))) {
 		ni_error("Unable to create policy object for %s", pname);
 		goto error;
@@ -801,8 +807,10 @@ ni_nanny_process_rename_event(ni_nanny_t *mgr, ni_ifworker_t *w)
 		rebuild = TRUE;
 	}
 
-	if (rebuild)
+	if (rebuild) {
 		ni_fsm_build_hierarchy(mgr->fsm, FALSE);
+		ni_fsm_print_config_hierarchy(mgr->fsm, NULL, NULL);
+	}
 }
 
 static void
@@ -950,23 +958,6 @@ ni_objectmodel_nanny_create_policy(ni_dbus_object_t *object, const ni_dbus_metho
 	return ni_dbus_message_append_object_path(reply, ni_dbus_object_get_path(policy_object));
 }
 
-ni_bool_t
-ni_nanny_policy_drop(const char *pname)
-{
-	char path[PATH_MAX] = {'\0'};
-
-	ni_managed_policy_filename(pname, path, sizeof(path));
-
-	if (unlink(path) < 0) {
-		if (errno == ENOENT)
-			return TRUE;
-
-		ni_error("Cannot remove policy file '%s': %m", path);
-		return FALSE;
-	}
-	return TRUE;
-}
-
 /*
  * Nanny.deletePolicy()
  */
@@ -1150,8 +1141,10 @@ ni_nanny_recheck_policies(ni_nanny_t *mgr, const ni_string_array_t *ifnames)
 		}
 	}
 
-	if (count)
+	if (count) {
 		ni_fsm_build_hierarchy(mgr->fsm, FALSE);
+		ni_fsm_print_config_hierarchy(mgr->fsm, NULL, NULL);
+	}
 }
 
 static dbus_bool_t
diff --git a/nanny/nanny.h b/nanny/nanny.h
index 8f735c9c7..c368784eb 100644
--- a/nanny/nanny.h
+++ b/nanny/nanny.h
@@ -15,6 +15,13 @@
 #include <wicked/secret.h>
 #include "appconfig.h"
 
+#ifndef NI_NANNY_POLICY_XML
+#define NI_NANNY_POLICY_XML	".xml"
+#endif
+#ifndef NI_NANNY_POLICY_BAK
+#define NI_NANNY_POLICY_BAK	".bak"
+#endif
+
 typedef struct ni_nanny		ni_nanny_t;
 typedef struct ni_managed_device ni_managed_device_t;
 typedef struct ni_managed_policy ni_managed_policy_t;
@@ -117,6 +124,11 @@ extern ni_nanny_t *		ni_nanny_new(void);
 extern void			ni_nanny_start(ni_nanny_t *);
 extern void			ni_nanny_free(ni_nanny_t *);
 extern const char *		ni_nanny_statedir(void);
+extern const char *		ni_nanny_policy_location(char **, const char *);
+extern const char *		ni_nanny_policy_file_name(char **, const char *);
+extern const char *		ni_nanny_policy_file_path(char **, const char *);
+extern ni_bool_t		ni_nanny_policy_drop(const char *);
+extern ni_bool_t		ni_nanny_policy_save(const xml_node_t *, const char *, const char *);
 extern void			ni_nanny_recheck_policies(ni_nanny_t *, const ni_string_array_t *);
 extern void			ni_nanny_schedule_recheck(ni_ifworker_array_t *, ni_ifworker_t *);
 extern void			ni_nanny_unschedule(ni_ifworker_array_t *, ni_ifworker_t *);
